//KONPEKI no Kantai 2 Perfect
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>

unsigned long decodeRLE( unsigned char *buf, unsigned long size, FILE *out )
{
	unsigned long	i = 0;
	unsigned int	q = 0;
	unsigned long	dest_size = 0;
	unsigned char	b1 = 0;
	unsigned char	b2 = 0;
	unsigned char	b3 = 0;

	b1 = buf[i]; i++;

	while( i < size )
	{
		b2 = buf[i];
		i++;

		if( b1 == b2 )
		{
			fprintf( out, "%c", b1 );
			fprintf( out, "%c", b2 );
			dest_size += 2;
			b3 = buf[i]; i++;

			for( q = 2; q != b3; q++ )
			{
				fprintf( out, "%c", b1 );
				dest_size++;
			}
			b1 = buf[i]; i++;
		} else {
			fprintf( out, "%c", b1 );
			dest_size++;
			b1 = b2;
		}
	}
	fprintf( out, "%c", b1 );
	dest_size++;

	return dest_size;
}

void main( void )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	header_filest = 0L;
	unsigned long	header_fileed = 0L;
	unsigned long	header_filesize = 0L;
	char			out_filename[13];
	int				count = 16;
	int				i = 0;

	printf( "MICROCABIN KONPEKI2 BGMSE.DAT Divider 060123 (c)Fac.KUROHANE\n" );

	in = fopen( "BGMSE.DB2", "rb" );
	if( in == NULL )
	{
		printf( "error: can't open BGMSE.DB2\n" );
		return;
	}

	printf( "\n" );

	//header
	buf = ( unsigned char * )calloc( 1, 0x100 );
	fread( buf, 0x54, 1, in );
/*
                 10 byte
+-------------------------------------+
| 02 | xx xx xx xx | 02 | xx xx xx xx |
+-------------------------------------+
          start          end(next start)
*/
	for( i = 0; i != count; i++ )
	{
		header_filest = *( unsigned int *)( buf + ( i * 5 ) + 1 );
		header_fileed = *( unsigned int *)( buf + ( i * 5 ) + 6 );
		header_filesize = header_fileed - header_filest;

		//14(BIN)
		if( i == 14 ) sprintf( out_filename, "BGMSE_%02d.BIN", i );
		else sprintf( out_filename, "BGMSE_%02d.BGM", i );

		printf( "%s %04lX-%04lX (%lu)\n",
			out_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", out_filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, header_filesize );

		fseek( in, header_filest, SEEK_SET );
		fread( filebuf, header_filesize, 1, in );

		//14(BIN) Decode
		if( i == 14 )
		{
			printf( "%s Decode (%lu -> %lu)\n",
				out_filename,
				header_filesize,
				decodeRLE( filebuf, header_filesize, out )
			);
		} else fwrite( filebuf, header_filesize, 1, out );
		fclose( out );

		free( filebuf );
	}

	printf( "complete.\n" );

end:;
	free( buf );
	fclose( in );

	return;
}
